library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
 
entity control_disp is
    PORT (
        clk   : IN  STD_LOGIC;
        reset : IN  STD_LOGIC;
        sal2  : Out STD_LOGIC;
		sal32 : Out STD_LOGIC
    );
end control_disp;
 
architecture control_arch of control_disp is
   
    signal cnt : unsigned(20 downto 0);

begin

    -- Proceso del contador, de 0 a 1 000 000.
    contador: process (reset, clk) begin
        if (reset = '1') then
            cnt <= (others => '0');
        elsif rising_edge(clk) then
            if (cnt = 1048000) then --En decimal
                cnt <= (others => '0');
            else
                cnt <= cnt + 1;
            end if;
        end if;
    end process;
	
sal2  <= '1' when ((cnt > 0) AND (cnt < 3 )) else '0';
sal32 <= '1' when ((cnt > 0) AND (cnt < 33)) else '0';

end control_arch;