library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
 
entity control_disp is
    PORT (
        clk   : IN  STD_LOGIC;
        reset : IN  STD_LOGIC;
        sal2  : Out STD_LOGIC;
		sal32 : Out STD_LOGIC
    );
end control_disp;
 
architecture control_arch of control_disp is
    -- Contador de 0 a 1279.
    signal cnt : unsigned(20 downto 0):="000000000000000000000";

begin

    -- Proceso del contador, de 0 a 1 000 000.
    contador: process (reset, clk) begin
        if (reset = '1') then
            cnt <="000000000000000000000";
        elsif (clk'event and clk='1') then
            if (cnt = "111111111111111111111") then --En decimal
                cnt <= "000000000000000000000";
            else
                cnt <= cnt + 1;
            end if;
        end if;
    end process;
	
sal2  <= '1' when ((cnt > "000000000000000000000") AND (cnt < "000000000000000000011" )) else '0';
sal32 <= '1' when ((cnt > "000000000000000000000") AND (cnt < "000000000000000100001")) else '0';

end control_arch;