-- VHDL netlist generated by SCUBA Diamond Version 3.8.0.115.3
-- Module  Version: 4.6
--C:\lscc\diamond\3.8\ispfpga\bin\nt\scuba.exe -w -n cont_BCD -lang vhdl -synth synplify -bus_exp 7 -bb -arch xo2c00 -type counter -up -width 4 -cnt_low 0 -cnt_up 9 

-- Wed Aug 30 19:25:30 2017

library IEEE;
use IEEE.std_logic_1164.all;
-- synopsys translate_off
library MACHXO2;
use MACHXO2.components.all;
-- synopsys translate_on

entity cont_BCD is
    port (
        Clock: in  std_logic; 
        Clk_En: in  std_logic; 
        Aclr: in  std_logic; 
        Q: out  std_logic_vector(3 downto 0));
end cont_BCD;

architecture Structure of cont_BCD is

    -- internal signal declarations
    signal tdataout2_inv: std_logic;
    signal tdataout1_inv: std_logic;
    signal dec0_sr9: std_logic;
    signal ldataout0: std_logic;
    signal ldataout1: std_logic;
    signal ldataout2: std_logic;
    signal ldataout3: std_logic;
    signal scuba_vlo: std_logic;
    signal scuba_vhi: std_logic;
    signal idataout0: std_logic;
    signal idataout1: std_logic;
    signal cnt_ci: std_logic;
    signal tdataout0: std_logic;
    signal tdataout1: std_logic;
    signal idataout2: std_logic;
    signal idataout3: std_logic;
    signal co1: std_logic;
    signal co0: std_logic;
    signal tdataout2: std_logic;
    signal tdataout3: std_logic;

    -- local component declarations
    component CU2
        port (CI: in  std_logic; PC0: in  std_logic; PC1: in  std_logic; 
            CO: out  std_logic; NC0: out  std_logic; NC1: out  std_logic);
    end component;
    component FADD2B
        port (A0: in  std_logic; A1: in  std_logic; B0: in  std_logic; 
            B1: in  std_logic; CI: in  std_logic; COUT: out  std_logic; 
            S0: out  std_logic; S1: out  std_logic);
    end component;
    component FD1P3DX
        port (D: in  std_logic; SP: in  std_logic; CK: in  std_logic; 
            CD: in  std_logic; Q: out  std_logic);
    end component;
    component INV
        port (A: in  std_logic; Z: out  std_logic);
    end component;
    component MUX21
        port (D0: in  std_logic; D1: in  std_logic; SD: in  std_logic; 
            Z: out  std_logic);
    end component;
    component ROM16X1A
        generic (INITVAL : in std_logic_vector(15 downto 0));
        port (AD3: in  std_logic; AD2: in  std_logic; AD1: in  std_logic; 
            AD0: in  std_logic; DO0: out  std_logic);
    end component;
    component VHI
        port (Z: out  std_logic);
    end component;
    component VLO
        port (Z: out  std_logic);
    end component;
    attribute GSR : string; 
    attribute GSR of FF_3 : label is "ENABLED";
    attribute GSR of FF_2 : label is "ENABLED";
    attribute GSR of FF_1 : label is "ENABLED";
    attribute GSR of FF_0 : label is "ENABLED";
    attribute syn_keep : boolean;
    attribute NGD_DRC_MASK : integer;
    attribute NGD_DRC_MASK of Structure : architecture is 1;

begin
    -- component instantiation statements
    INV_1: INV
        port map (A=>tdataout1, Z=>tdataout1_inv);

    INV_0: INV
        port map (A=>tdataout2, Z=>tdataout2_inv);

    LUT4_0: ROM16X1A
        generic map (initval=> X"8000")
        port map (AD3=>tdataout0, AD2=>tdataout1_inv, AD1=>tdataout2_inv, 
            AD0=>tdataout3, DO0=>dec0_sr9);

    muxb_3: MUX21
        port map (D0=>idataout0, D1=>scuba_vlo, SD=>dec0_sr9, 
            Z=>ldataout0);

    muxb_2: MUX21
        port map (D0=>idataout1, D1=>scuba_vlo, SD=>dec0_sr9, 
            Z=>ldataout1);

    muxb_1: MUX21
        port map (D0=>idataout2, D1=>scuba_vlo, SD=>dec0_sr9, 
            Z=>ldataout2);

    muxb_0: MUX21
        port map (D0=>idataout3, D1=>scuba_vlo, SD=>dec0_sr9, 
            Z=>ldataout3);

    FF_3: FD1P3DX
        port map (D=>ldataout0, SP=>Clk_En, CK=>Clock, CD=>Aclr, 
            Q=>tdataout0);

    FF_2: FD1P3DX
        port map (D=>ldataout1, SP=>Clk_En, CK=>Clock, CD=>Aclr, 
            Q=>tdataout1);

    FF_1: FD1P3DX
        port map (D=>ldataout2, SP=>Clk_En, CK=>Clock, CD=>Aclr, 
            Q=>tdataout2);

    FF_0: FD1P3DX
        port map (D=>ldataout3, SP=>Clk_En, CK=>Clock, CD=>Aclr, 
            Q=>tdataout3);

    scuba_vlo_inst: VLO
        port map (Z=>scuba_vlo);

    scuba_vhi_inst: VHI
        port map (Z=>scuba_vhi);

    cnt_cia: FADD2B
        port map (A0=>scuba_vlo, A1=>scuba_vhi, B0=>scuba_vlo, 
            B1=>scuba_vhi, CI=>scuba_vlo, COUT=>cnt_ci, S0=>open, 
            S1=>open);

    cnt_0: CU2
        port map (CI=>cnt_ci, PC0=>tdataout0, PC1=>tdataout1, CO=>co0, 
            NC0=>idataout0, NC1=>idataout1);

    cnt_1: CU2
        port map (CI=>co0, PC0=>tdataout2, PC1=>tdataout3, CO=>co1, 
            NC0=>idataout2, NC1=>idataout3);

    Q(0) <= tdataout0;
    Q(1) <= tdataout1;
    Q(2) <= tdataout2;
    Q(3) <= tdataout3;
end Structure;

-- synopsys translate_off
library MACHXO2;
configuration Structure_CON of cont_BCD is
    for Structure
        for all:CU2 use entity MACHXO2.CU2(V); end for;
        for all:FADD2B use entity MACHXO2.FADD2B(V); end for;
        for all:FD1P3DX use entity MACHXO2.FD1P3DX(V); end for;
        for all:INV use entity MACHXO2.INV(V); end for;
        for all:MUX21 use entity MACHXO2.MUX21(V); end for;
        for all:ROM16X1A use entity MACHXO2.ROM16X1A(V); end for;
        for all:VHI use entity MACHXO2.VHI(V); end for;
        for all:VLO use entity MACHXO2.VLO(V); end for;
    end for;
end Structure_CON;

-- synopsys translate_on
