#ifndef __SYSTEM_CONFIG_H_
#define __SYSTEM_CONFIG_H_


#define FPGA_DEVICE_FAMILY    "EC"
#define PLATFORM_NAME         "dos_gpio"
#define USE_PLL               (0)
#define CPU_FREQUENCY         (25000000)


/* FOUND 1 CPU UNIT(S) */

/*
 * CPU Instance LM8 component configuration
 */
#define CPU_NAME "LM8"

/*
 * gpioent component configuration
 */
#define GPIOENT_NAME  "gpioent"
#define GPIOENT_BASE_ADDRESS  (0x80000000)
#define GPIOENT_SIZE  (16)
#define GPIOENT_CHARIO_IN        (0)
#define GPIOENT_CHARIO_OUT       (0)
#define GPIOENT_WB_DAT_WIDTH  (8)
#define GPIOENT_WB_ADR_WIDTH  (4)
#define GPIOENT_ADDRESS_LOCK  (0)
#define GPIOENT_DISABLE  (0)
#define GPIOENT_OUTPUT_PORTS_ONLY  (0)
#define GPIOENT_INPUT_PORTS_ONLY  (1)
#define GPIOENT_TRISTATE_PORTS  (0)
#define GPIOENT_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOENT_DATA_WIDTH  (8)
#define GPIOENT_INPUT_WIDTH  (1)
#define GPIOENT_OUTPUT_WIDTH  (1)
#define GPIOENT_IRQ_MODE  (0)
#define GPIOENT_LEVEL  (0)
#define GPIOENT_EDGE  (0)
#define GPIOENT_EITHER_EDGE_IRQ  (0)
#define GPIOENT_POSE_EDGE_IRQ  (0)
#define GPIOENT_NEGE_EDGE_IRQ  (0)

/*
 * gpiosal component configuration
 */
#define GPIOSAL_NAME  "gpiosal"
#define GPIOSAL_BASE_ADDRESS  (0x80000010)
#define GPIOSAL_SIZE  (16)
#define GPIOSAL_CHARIO_IN        (0)
#define GPIOSAL_CHARIO_OUT       (0)
#define GPIOSAL_WB_DAT_WIDTH  (8)
#define GPIOSAL_WB_ADR_WIDTH  (4)
#define GPIOSAL_ADDRESS_LOCK  (0)
#define GPIOSAL_DISABLE  (0)
#define GPIOSAL_OUTPUT_PORTS_ONLY  (1)
#define GPIOSAL_INPUT_PORTS_ONLY  (0)
#define GPIOSAL_TRISTATE_PORTS  (0)
#define GPIOSAL_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOSAL_DATA_WIDTH  (8)
#define GPIOSAL_INPUT_WIDTH  (1)
#define GPIOSAL_OUTPUT_WIDTH  (1)
#define GPIOSAL_IRQ_MODE  (0)
#define GPIOSAL_LEVEL  (0)
#define GPIOSAL_EDGE  (0)
#define GPIOSAL_EITHER_EDGE_IRQ  (0)
#define GPIOSAL_POSE_EDGE_IRQ  (0)
#define GPIOSAL_NEGE_EDGE_IRQ  (0)


#endif /* __SYSTEM_CONFIG_H_ */
