#-- Lattice Semiconductor Corporation Ltd.
#-- Synplify OEM project file

#device options
set_option -technology MACHXO2
set_option -part LCMXO2_1200ZE
set_option -package TG144C
set_option -speed_grade -1

#compilation/mapping options
set_option -symbolic_fsm_compiler true
set_option -resource_sharing true

#use verilog 2001 standard option
set_option -vlog_std v2001

#map options
set_option -frequency auto
set_option -maxfan 1000
set_option -auto_constrain_io 0
set_option -disable_io_insertion false
set_option -retiming false; set_option -pipe true
set_option -force_gsr false
set_option -compiler_compatible 0
set_option -dup false
set_option -frequency 1
set_option -default_enum_encoding default

#simulation options


#timing analysis options



#automatic place and route (vendor) options
set_option -write_apr_constraint 1

#synplifyPro options
set_option -fix_gated_and_generated_clocks 1
set_option -update_models_cp 0
set_option -resolve_multiple_driver 0


#-- add_file options
set_option -include_path {C:/TFG/exp3}
add_file -verilog {C:/TFG/exp3/proyecto_global/esquema_global.v}
add_file -vhdl -lib "work" {C:/TFG/exp3/divfrec1.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/cont_BCD.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/DECODIF.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/pll1.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/cont_50mhz_1mhz.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/cont_disp.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/control_disp.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/dos_gpio/soc/dos_gpio_vhd.vhd}
add_file -verilog {C:/TFG/exp3/dos_gpio/soc/dos_gpio.v}
add_file -vhdl -lib "work" {C:/TFG/exp3/div2.vhd}
add_file -vhdl -lib "work" {C:/TFG/exp3/conver_bus.vhd}

#-- top module name
set_option -top_module esquema_global

#-- set result format/file last
project -result_file {C:/TFG/exp3/proyecto_global/proyecto_global_proyecto_global.edi}

#-- error message log file
project -log_file {proyecto_global_proyecto_global.srf}

#-- set any command lines input by customer


#-- run Synplify with 'arrange HDL file'
project -run hdl_info_gen -fileorder
project -run
