#ifndef __SYSTEM_CONFIG_H_
#define __SYSTEM_CONFIG_H_


#define FPGA_DEVICE_FAMILY    "EC"
#define PLATFORM_NAME         "dos_gpio"
#define USE_PLL               (0)
#define CPU_FREQUENCY         (25000000)


/* FOUND 1 CPU UNIT(S) */

/*
 * CPU Instance LM8 component configuration
 */
#define CPU_NAME "LM8"

/*
 * gpioentpeq component configuration
 */
#define GPIOENTPEQ_NAME  "gpioentpeq"
#define GPIOENTPEQ_BASE_ADDRESS  (0x80000000)
#define GPIOENTPEQ_SIZE  (16)
#define GPIOENTPEQ_CHARIO_IN        (0)
#define GPIOENTPEQ_CHARIO_OUT       (0)
#define GPIOENTPEQ_WB_DAT_WIDTH  (8)
#define GPIOENTPEQ_WB_ADR_WIDTH  (4)
#define GPIOENTPEQ_ADDRESS_LOCK  (0)
#define GPIOENTPEQ_DISABLE  (0)
#define GPIOENTPEQ_OUTPUT_PORTS_ONLY  (0)
#define GPIOENTPEQ_INPUT_PORTS_ONLY  (1)
#define GPIOENTPEQ_TRISTATE_PORTS  (0)
#define GPIOENTPEQ_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOENTPEQ_DATA_WIDTH  (4)
#define GPIOENTPEQ_INPUT_WIDTH  (1)
#define GPIOENTPEQ_OUTPUT_WIDTH  (1)
#define GPIOENTPEQ_IRQ_MODE  (0)
#define GPIOENTPEQ_LEVEL  (0)
#define GPIOENTPEQ_EDGE  (0)
#define GPIOENTPEQ_EITHER_EDGE_IRQ  (0)
#define GPIOENTPEQ_POSE_EDGE_IRQ  (0)
#define GPIOENTPEQ_NEGE_EDGE_IRQ  (0)

/*
 * gpioentmed component configuration
 */
#define GPIOENTMED_NAME  "gpioentmed"
#define GPIOENTMED_BASE_ADDRESS  (0x80000010)
#define GPIOENTMED_SIZE  (16)
#define GPIOENTMED_CHARIO_IN        (0)
#define GPIOENTMED_CHARIO_OUT       (0)
#define GPIOENTMED_WB_DAT_WIDTH  (8)
#define GPIOENTMED_WB_ADR_WIDTH  (4)
#define GPIOENTMED_ADDRESS_LOCK  (0)
#define GPIOENTMED_DISABLE  (0)
#define GPIOENTMED_OUTPUT_PORTS_ONLY  (0)
#define GPIOENTMED_INPUT_PORTS_ONLY  (1)
#define GPIOENTMED_TRISTATE_PORTS  (0)
#define GPIOENTMED_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOENTMED_DATA_WIDTH  (4)
#define GPIOENTMED_INPUT_WIDTH  (1)
#define GPIOENTMED_OUTPUT_WIDTH  (1)
#define GPIOENTMED_IRQ_MODE  (0)
#define GPIOENTMED_LEVEL  (0)
#define GPIOENTMED_EDGE  (0)
#define GPIOENTMED_EITHER_EDGE_IRQ  (0)
#define GPIOENTMED_POSE_EDGE_IRQ  (0)
#define GPIOENTMED_NEGE_EDGE_IRQ  (0)

/*
 * gpioentgran component configuration
 */
#define GPIOENTGRAN_NAME  "gpioentgran"
#define GPIOENTGRAN_BASE_ADDRESS  (0x80000020)
#define GPIOENTGRAN_SIZE  (16)
#define GPIOENTGRAN_CHARIO_IN        (0)
#define GPIOENTGRAN_CHARIO_OUT       (0)
#define GPIOENTGRAN_WB_DAT_WIDTH  (8)
#define GPIOENTGRAN_WB_ADR_WIDTH  (4)
#define GPIOENTGRAN_ADDRESS_LOCK  (0)
#define GPIOENTGRAN_DISABLE  (0)
#define GPIOENTGRAN_OUTPUT_PORTS_ONLY  (0)
#define GPIOENTGRAN_INPUT_PORTS_ONLY  (1)
#define GPIOENTGRAN_TRISTATE_PORTS  (0)
#define GPIOENTGRAN_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOENTGRAN_DATA_WIDTH  (4)
#define GPIOENTGRAN_INPUT_WIDTH  (1)
#define GPIOENTGRAN_OUTPUT_WIDTH  (1)
#define GPIOENTGRAN_IRQ_MODE  (0)
#define GPIOENTGRAN_LEVEL  (0)
#define GPIOENTGRAN_EDGE  (0)
#define GPIOENTGRAN_EITHER_EDGE_IRQ  (0)
#define GPIOENTGRAN_POSE_EDGE_IRQ  (0)
#define GPIOENTGRAN_NEGE_EDGE_IRQ  (0)

/*
 * gpiosalpeq component configuration
 */
#define GPIOSALPEQ_NAME  "gpiosalpeq"
#define GPIOSALPEQ_BASE_ADDRESS  (0x80000030)
#define GPIOSALPEQ_SIZE  (16)
#define GPIOSALPEQ_CHARIO_IN        (0)
#define GPIOSALPEQ_CHARIO_OUT       (0)
#define GPIOSALPEQ_WB_DAT_WIDTH  (8)
#define GPIOSALPEQ_WB_ADR_WIDTH  (4)
#define GPIOSALPEQ_ADDRESS_LOCK  (0)
#define GPIOSALPEQ_DISABLE  (0)
#define GPIOSALPEQ_OUTPUT_PORTS_ONLY  (1)
#define GPIOSALPEQ_INPUT_PORTS_ONLY  (0)
#define GPIOSALPEQ_TRISTATE_PORTS  (0)
#define GPIOSALPEQ_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOSALPEQ_DATA_WIDTH  (4)
#define GPIOSALPEQ_INPUT_WIDTH  (1)
#define GPIOSALPEQ_OUTPUT_WIDTH  (1)
#define GPIOSALPEQ_IRQ_MODE  (0)
#define GPIOSALPEQ_LEVEL  (0)
#define GPIOSALPEQ_EDGE  (0)
#define GPIOSALPEQ_EITHER_EDGE_IRQ  (0)
#define GPIOSALPEQ_POSE_EDGE_IRQ  (0)
#define GPIOSALPEQ_NEGE_EDGE_IRQ  (0)

/*
 * gpiosalmed component configuration
 */
#define GPIOSALMED_NAME  "gpiosalmed"
#define GPIOSALMED_BASE_ADDRESS  (0x80000040)
#define GPIOSALMED_SIZE  (16)
#define GPIOSALMED_CHARIO_IN        (0)
#define GPIOSALMED_CHARIO_OUT       (0)
#define GPIOSALMED_WB_DAT_WIDTH  (8)
#define GPIOSALMED_WB_ADR_WIDTH  (4)
#define GPIOSALMED_ADDRESS_LOCK  (0)
#define GPIOSALMED_DISABLE  (0)
#define GPIOSALMED_OUTPUT_PORTS_ONLY  (1)
#define GPIOSALMED_INPUT_PORTS_ONLY  (0)
#define GPIOSALMED_TRISTATE_PORTS  (0)
#define GPIOSALMED_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOSALMED_DATA_WIDTH  (4)
#define GPIOSALMED_INPUT_WIDTH  (1)
#define GPIOSALMED_OUTPUT_WIDTH  (1)
#define GPIOSALMED_IRQ_MODE  (0)
#define GPIOSALMED_LEVEL  (0)
#define GPIOSALMED_EDGE  (0)
#define GPIOSALMED_EITHER_EDGE_IRQ  (0)
#define GPIOSALMED_POSE_EDGE_IRQ  (0)
#define GPIOSALMED_NEGE_EDGE_IRQ  (0)

/*
 * gpiocont component configuration
 */
#define GPIOCONT_NAME  "gpiocont"
#define GPIOCONT_BASE_ADDRESS  (0x80000050)
#define GPIOCONT_SIZE  (16)
#define GPIOCONT_CHARIO_IN        (0)
#define GPIOCONT_CHARIO_OUT       (0)
#define GPIOCONT_WB_DAT_WIDTH  (8)
#define GPIOCONT_WB_ADR_WIDTH  (4)
#define GPIOCONT_ADDRESS_LOCK  (0)
#define GPIOCONT_DISABLE  (0)
#define GPIOCONT_OUTPUT_PORTS_ONLY  (0)
#define GPIOCONT_INPUT_PORTS_ONLY  (1)
#define GPIOCONT_TRISTATE_PORTS  (0)
#define GPIOCONT_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOCONT_DATA_WIDTH  (4)
#define GPIOCONT_INPUT_WIDTH  (1)
#define GPIOCONT_OUTPUT_WIDTH  (1)
#define GPIOCONT_IRQ_MODE  (0)
#define GPIOCONT_LEVEL  (0)
#define GPIOCONT_EDGE  (0)
#define GPIOCONT_EITHER_EDGE_IRQ  (0)
#define GPIOCONT_POSE_EDGE_IRQ  (0)
#define GPIOCONT_NEGE_EDGE_IRQ  (0)

/*
 * gpiosalgran component configuration
 */
#define GPIOSALGRAN_NAME  "gpiosalgran"
#define GPIOSALGRAN_BASE_ADDRESS  (0x80000060)
#define GPIOSALGRAN_SIZE  (16)
#define GPIOSALGRAN_CHARIO_IN        (0)
#define GPIOSALGRAN_CHARIO_OUT       (0)
#define GPIOSALGRAN_WB_DAT_WIDTH  (8)
#define GPIOSALGRAN_WB_ADR_WIDTH  (4)
#define GPIOSALGRAN_ADDRESS_LOCK  (0)
#define GPIOSALGRAN_DISABLE  (0)
#define GPIOSALGRAN_OUTPUT_PORTS_ONLY  (1)
#define GPIOSALGRAN_INPUT_PORTS_ONLY  (0)
#define GPIOSALGRAN_TRISTATE_PORTS  (0)
#define GPIOSALGRAN_BOTH_INPUT_AND_OUTPUT  (0)
#define GPIOSALGRAN_DATA_WIDTH  (4)
#define GPIOSALGRAN_INPUT_WIDTH  (1)
#define GPIOSALGRAN_OUTPUT_WIDTH  (1)
#define GPIOSALGRAN_IRQ_MODE  (0)
#define GPIOSALGRAN_LEVEL  (0)
#define GPIOSALGRAN_EDGE  (0)
#define GPIOSALGRAN_EITHER_EDGE_IRQ  (0)
#define GPIOSALGRAN_POSE_EDGE_IRQ  (0)
#define GPIOSALGRAN_NEGE_EDGE_IRQ  (0)


#endif /* __SYSTEM_CONFIG_H_ */
