/**************************************************************
 * This example exercises LEDs on LatticeMico32 Development   *
 * board.                                                     *
 *                                                            *
 *                                                            *
 *                                                            *
 *------------------------------------------------------------*
 * PREREQUISITES:                                             *
 *                                                            *                                                                                                    
 * - GPIO with 8-bit output named LED connected to the        *
 *   board's LED pins.                                        *
 **************************************************************/
#include "DDStructs.h"
#include "LookupServices.h"
//#include "stdio.h"
#include "MicoUtils.h"

const char *LED_GPIO_INSTANCE = "LED";
const unsigned int uiBlink = 1;

int main(void)
{
	unsigned char iValue = 0x1;
	unsigned char iShiftLeft = 1;

    /* Fetch GPIO instance named "LED" */
	MicoGPIOCtx_t *leds = (MicoGPIOCtx_t *)MicoGetDevice(LED_GPIO_INSTANCE);
    if (leds == 0) {
  //      printf("failed to find GPIO instance named LED\r\n");
        return(0);
    }
   // printf("found GPIO instance named LED\r\n");
	
    /* if we're not to blink, return immediately */
    if (uiBlink == 0)
        return(0);
	
    /* scroll the LEDs, every 100 msecs forever */
	while(1) {
		*((volatile unsigned char *)(leds->base)) = ~iValue;
		MicoSleepMilliSecs(1000);
		if (iShiftLeft == 1){
			if (iValue == 0x80) {
				iShiftLeft = 0;
				iValue = 0x40;
			} else {
				iValue = iValue << 1;
			}
		} else {
			iValue = iValue >> 1;
			if (iValue == 0) {
				iValue = 0x02;
				iShiftLeft = 1;
			}
		}
	}
	
    /* all done */
	return(0);
}

