#ifndef __SYSTEM_CONFIG_H_
#define __SYSTEM_CONFIG_H_


#define FPGA_DEVICE_FAMILY    "MachXO2"
#define PLATFORM_NAME         "mic32"
#define USE_PLL               (0)
#define CPU_FREQUENCY         (25000000)


/* FOUND 1 CPU UNIT(S) */

/*
 * CPU Instance LM32 component configuration
 */
#define CPU_NAME "LM32"
#define CPU_EBA (0x00000000)
#define CPU_DIVIDE_ENABLED (0)
#define CPU_SIGN_EXTEND_ENABLED (0)
#define CPU_MULTIPLIER_ENABLED (0)
#define CPU_SHIFT_ENABLED (1)
#define CPU_DEBUG_ENABLED (0)
#define CPU_HW_BREAKPOINTS_ENABLED (0)
#define CPU_NUM_HW_BREAKPOINTS (0)
#define CPU_NUM_WATCHPOINTS (0)
#define CPU_ICACHE_ENABLED (0)
#define CPU_ICACHE_SETS (128)
#define CPU_ICACHE_ASSOC (1)
#define CPU_ICACHE_BYTES_PER_LINE (4)
#define CPU_DCACHE_ENABLED (0)
#define CPU_DCACHE_SETS (128)
#define CPU_DCACHE_ASSOC (1)
#define CPU_DCACHE_BYTES_PER_LINE (4)
#define CPU_DEBA (0x00000000)
#define CPU_CHARIO_IN        (0)
#define CPU_CHARIO_OUT       (0)
#define CPU_CHARIO_TYPE      "JTAG UART"

/*
 * LED component configuration
 */
#define LED_NAME  "LED"
#define LED_BASE_ADDRESS  (0x80000000)
#define LED_SIZE  (16)
#define LED_CHARIO_IN        (0)
#define LED_CHARIO_OUT       (0)
#define LED_WB_DAT_WIDTH  (32)
#define LED_WB_ADR_WIDTH  (4)
#define LED_ADDRESS_LOCK  (0)
#define LED_DISABLE  (0)
#define LED_OUTPUT_PORTS_ONLY  (1)
#define LED_INPUT_PORTS_ONLY  (0)
#define LED_TRISTATE_PORTS  (0)
#define LED_BOTH_INPUT_AND_OUTPUT  (0)
#define LED_DATA_WIDTH  (8)
#define LED_INPUT_WIDTH  (1)
#define LED_OUTPUT_WIDTH  (1)
#define LED_IRQ_MODE  (0)
#define LED_LEVEL  (0)
#define LED_EDGE  (0)
#define LED_EITHER_EDGE_IRQ  (0)
#define LED_POSE_EDGE_IRQ  (0)
#define LED_NEGE_EDGE_IRQ  (0)

/*
 * sram component configuration
 */
#define SRAM_NAME  "sram"
#define SRAM_BASE_ADDRESS  (0x00000000)
#define SRAM_SIZE  (1048576)
#define SRAM_IS_READABLE   (1)
#define SRAM_IS_WRITABLE   (1)
#define SRAM_ADDRESS_LOCK  (0)
#define SRAM_SHARED  (1)
#define SRAM_DISABLE  (0)
#define SRAM_READ_LATENCY  (1)
#define SRAM_WRITE_LATENCY  (1)
#define SRAM_SRAM_ADDR_WIDTH  (23)
#define SRAM_SRAM_DATA_WIDTH  (8)
#define SRAM_SRAM_BE_WIDTH  (4)
#define SRAM_DATA_OUTPUT_REG  (0)
#define SRAM_WB_DAT_WIDTH  (8)

/*
 * flash component configuration
 */
#define FLASH_NAME  "flash"
#define FLASH_BASE_ADDRESS  (0x00100000)
#define FLASH_SIZE  (1048576)
#define FLASH_IS_READABLE   (1)
#define FLASH_IS_WRITABLE   (0)
#define FLASH_ADDRESS_LOCK  (0)
#define FLASH_SHARED  (1)
#define FLASH_DISABLE  (0)
#define FLASH_READ_LATENCY  (7)
#define FLASH_WRITE_LATENCY  (7)
#define FLASH_SRAM_ADDR_WIDTH  (25)
#define FLASH_SRAM_DATA_WIDTH  (32)
#define FLASH_SRAM_BE_WIDTH  (4)
#define FLASH_FLASH_SIGNALS  (1)
#define FLASH_FLASH_BYTE_ENB  (1)
#define FLASH_FLASH_BYTE  (0)
#define FLASH_FLASH_BYTEN  (1)
#define FLASH_FLASH_WP_ENB  (1)
#define FLASH_FLASH_WP  (0)
#define FLASH_FLASH_WPN  (1)
#define FLASH_FLASH_RST_ENB  (1)
#define FLASH_FLASH_RST  (0)
#define FLASH_FLASH_RSTN  (1)


#endif /* __SYSTEM_CONFIG_H_ */
