//   ==================================================================
//   >>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<
//   ------------------------------------------------------------------
//   Copyright (c) 2006-2011 by Lattice Semiconductor Corporation
//   ALL RIGHTS RESERVED 
//   ------------------------------------------------------------------
//
//   IMPORTANT: THIS FILE IS AUTO-GENERATED BY THE LATTICEMICO SYSTEM.
//
//   Permission:
//
//      Lattice Semiconductor grants permission to use this code
//      pursuant to the terms of the Lattice Semiconductor Corporation
//      Open Source License Agreement.  
//
//   Disclaimer:
//
//      Lattice Semiconductor provides no warranty regarding the use or
//      functionality of this code. It is the user's responsibility to
//      verify the users design for consistency and functionality through
//      the use of formal verification methods.
//
//   --------------------------------------------------------------------
//
//                  Lattice Semiconductor Corporation
//                  5555 NE Moore Court
//                  Hillsboro, OR 97214
//                  U.S.A
//
//                  TEL: 1-800-Lattice (USA and Canada)
//                         503-286-8001 (other locations)
//
//                  web: http://www.latticesemi.com/
//                  email: techsupport@latticesemi.com
//
//   --------------------------------------------------------------------
//                         FILE DETAILS
// Project          : LatticeMico32
// File             : jtag_lm32.v
// Title            : JTAG data register for LM32 CPU debug interface
// Version          : 6.0.13
//                  : Initial Release
// Version          : 7.0SP2, 3.0
//                  : No Change
// Version          : 3.1
//                  : No Change
// Version          : 3.9
//                  : Support added for 'Fast Download' register in Debugger
// =============================================================================

module jtag_lm32 (
       input JTCK,
       input JTDI,
       output JTDO2,
       input JSHIFT,
       input JUPDATE,
       input JRSTN,
       input JCE2,
       input JTAGREG_ENABLE,
       input CONTROL_DATAN,
       output REG_UPDATE,
       input [7:0] REG_D,
       input [2:0] REG_ADDR_D,
`ifdef CFG_FAST_DOWNLOAD_ENABLED
       output [`DOWNLOAD_BUFFER_SIZE-1:0] REG_Q,
`else
       output [7:0] REG_Q,
`endif
       output [2:0] REG_ADDR_Q);

`ifdef CFG_FAST_DOWNLOAD_ENABLED
wire [`DOWNLOAD_BUFFER_SIZE+1:0] tdibus ; 
`else
wire [9:0] tdibus ; 
`endif

TYPEA DATA_BIT0 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (JTDI),
      .TDO        (tdibus[0]),
      .DATA_OUT   (REG_Q[0]),
      .DATA_IN    (REG_D[0]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT1 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[0]),
      .TDO        (tdibus[1]),
      .DATA_OUT   (REG_Q[1]),
      .DATA_IN    (REG_D[1]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT2 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[1]),
      .TDO        (tdibus[2]),
      .DATA_OUT   (REG_Q[2]),
      .DATA_IN    (REG_D[2]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT3 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[2]),
      .TDO        (tdibus[3]),
      .DATA_OUT   (REG_Q[3]),
      .DATA_IN    (REG_D[3]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT4 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[3]),
      .TDO        (tdibus[4]),
      .DATA_OUT   (REG_Q[4]),
      .DATA_IN    (REG_D[4]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT5 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[4]),
      .TDO        (tdibus[5]),
      .DATA_OUT   (REG_Q[5]),
      .DATA_IN    (REG_D[5]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT6 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[5]),
      .TDO        (tdibus[6]),
      .DATA_OUT   (REG_Q[6]),
      .DATA_IN    (REG_D[6]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT7 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[6]),
      .TDO        (tdibus[7]),
      .DATA_OUT   (REG_Q[7]),
      .DATA_IN    (REG_D[7]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

`ifdef CFG_FAST_DOWNLOAD_ENABLED
TYPEA DATA_BIT8 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[10]),
      .TDO        (tdibus[11]),
      .DATA_OUT   (REG_Q[8]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT9 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[11]),
      .TDO        (tdibus[12]),
      .DATA_OUT   (REG_Q[9]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT10 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[12]),
      .TDO        (tdibus[13]),
      .DATA_OUT   (REG_Q[10]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT11 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[13]),
      .TDO        (tdibus[14]),
      .DATA_OUT   (REG_Q[11]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT12 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[14]),
      .TDO        (tdibus[15]),
      .DATA_OUT   (REG_Q[12]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT13 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[15]),
      .TDO        (tdibus[16]),
      .DATA_OUT   (REG_Q[13]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT14 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[16]),
      .TDO        (tdibus[17]),
      .DATA_OUT   (REG_Q[14]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT15 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[17]),
      .TDO        (tdibus[18]),
      .DATA_OUT   (REG_Q[15]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT16 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[18]),
      .TDO        (tdibus[19]),
      .DATA_OUT   (REG_Q[16]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT17 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[19]),
      .TDO        (tdibus[20]),
      .DATA_OUT   (REG_Q[17]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT18 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[20]),
      .TDO        (tdibus[21]),
      .DATA_OUT   (REG_Q[18]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT19 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[21]),
      .TDO        (tdibus[22]),
      .DATA_OUT   (REG_Q[19]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT20 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[22]),
      .TDO        (tdibus[23]),
      .DATA_OUT   (REG_Q[20]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT21 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[23]),
      .TDO        (tdibus[24]),
      .DATA_OUT   (REG_Q[21]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT22 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[24]),
      .TDO        (tdibus[25]),
      .DATA_OUT   (REG_Q[22]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT23 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[25]),
      .TDO        (tdibus[26]),
      .DATA_OUT   (REG_Q[23]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT24 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[26]),
      .TDO        (tdibus[27]),
      .DATA_OUT   (REG_Q[24]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT25 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[27]),
      .TDO        (tdibus[28]),
      .DATA_OUT   (REG_Q[25]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT26 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[28]),
      .TDO        (tdibus[29]),
      .DATA_OUT   (REG_Q[26]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT27 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[29]),
      .TDO        (tdibus[30]),
      .DATA_OUT   (REG_Q[27]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT28 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[30]),
      .TDO        (tdibus[31]),
      .DATA_OUT   (REG_Q[28]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT29 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[31]),
      .TDO        (tdibus[32]),
      .DATA_OUT   (REG_Q[29]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT30 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[32]),
      .TDO        (tdibus[33]),
      .DATA_OUT   (REG_Q[30]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT31 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[33]),
      .TDO        (tdibus[34]),
      .DATA_OUT   (REG_Q[31]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT32 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[34]),
      .TDO        (tdibus[35]),
      .DATA_OUT   (REG_Q[32]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT33 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[35]),
      .TDO        (tdibus[36]),
      .DATA_OUT   (REG_Q[33]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT34 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[36]),
      .TDO        (tdibus[37]),
      .DATA_OUT   (REG_Q[34]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT35 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[37]),
      .TDO        (tdibus[38]),
      .DATA_OUT   (REG_Q[35]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT36 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[38]),
      .TDO        (tdibus[39]),
      .DATA_OUT   (REG_Q[36]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT37 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[39]),
      .TDO        (tdibus[40]),
      .DATA_OUT   (REG_Q[37]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT38 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[40]),
      .TDO        (tdibus[41]),
      .DATA_OUT   (REG_Q[38]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT39 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[41]),
      .TDO        (tdibus[42]),
      .DATA_OUT   (REG_Q[39]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT40 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[42]),
      .TDO        (tdibus[43]),
      .DATA_OUT   (REG_Q[40]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT41 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[43]),
      .TDO        (tdibus[44]),
      .DATA_OUT   (REG_Q[41]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT42 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[44]),
      .TDO        (tdibus[45]),
      .DATA_OUT   (REG_Q[42]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT43 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[45]),
      .TDO        (tdibus[46]),
      .DATA_OUT   (REG_Q[43]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT44 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[46]),
      .TDO        (tdibus[47]),
      .DATA_OUT   (REG_Q[44]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT45 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[47]),
      .TDO        (tdibus[48]),
      .DATA_OUT   (REG_Q[45]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT46 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[48]),
      .TDO        (tdibus[49]),
      .DATA_OUT   (REG_Q[46]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT47 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[49]),
      .TDO        (tdibus[50]),
      .DATA_OUT   (REG_Q[47]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT48 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[50]),
      .TDO        (tdibus[51]),
      .DATA_OUT   (REG_Q[48]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT49 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[51]),
      .TDO        (tdibus[52]),
      .DATA_OUT   (REG_Q[49]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT50 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[52]),
      .TDO        (tdibus[53]),
      .DATA_OUT   (REG_Q[50]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT51 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[53]),
      .TDO        (tdibus[54]),
      .DATA_OUT   (REG_Q[51]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT52 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[54]),
      .TDO        (tdibus[55]),
      .DATA_OUT   (REG_Q[52]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT53 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[55]),
      .TDO        (tdibus[56]),
      .DATA_OUT   (REG_Q[53]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT54 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[56]),
      .TDO        (tdibus[57]),
      .DATA_OUT   (REG_Q[54]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT55 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[57]),
      .TDO        (tdibus[58]),
      .DATA_OUT   (REG_Q[55]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT56 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[58]),
      .TDO        (tdibus[59]),
      .DATA_OUT   (REG_Q[56]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT57 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[59]),
      .TDO        (tdibus[60]),
      .DATA_OUT   (REG_Q[57]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT58 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[60]),
      .TDO        (tdibus[61]),
      .DATA_OUT   (REG_Q[58]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT59 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[61]),
      .TDO        (tdibus[62]),
      .DATA_OUT   (REG_Q[59]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT60 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[62]),
      .TDO        (tdibus[63]),
      .DATA_OUT   (REG_Q[60]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT61 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[63]),
      .TDO        (tdibus[64]),
      .DATA_OUT   (REG_Q[61]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT62 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[64]),
      .TDO        (tdibus[65]),
      .DATA_OUT   (REG_Q[62]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT63 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[65]),
      .TDO        (tdibus[66]),
      .DATA_OUT   (REG_Q[63]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT64 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[66]),
      .TDO        (tdibus[67]),
      .DATA_OUT   (REG_Q[64]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT65 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[67]),
      .TDO        (tdibus[68]),
      .DATA_OUT   (REG_Q[65]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT66 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[68]),
      .TDO        (tdibus[69]),
      .DATA_OUT   (REG_Q[66]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT67 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[69]),
      .TDO        (tdibus[70]),
      .DATA_OUT   (REG_Q[67]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT68 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[70]),
      .TDO        (tdibus[71]),
      .DATA_OUT   (REG_Q[68]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT69 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[71]),
      .TDO        (tdibus[72]),
      .DATA_OUT   (REG_Q[69]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT70 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[72]),
      .TDO        (tdibus[73]),
      .DATA_OUT   (REG_Q[70]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT71 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[73]),
      .TDO        (tdibus[74]),
      .DATA_OUT   (REG_Q[71]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT72 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[74]),
      .TDO        (tdibus[75]),
      .DATA_OUT   (REG_Q[72]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT73 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[75]),
      .TDO        (tdibus[76]),
      .DATA_OUT   (REG_Q[73]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT74 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[76]),
      .TDO        (tdibus[77]),
      .DATA_OUT   (REG_Q[74]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT75 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[77]),
      .TDO        (tdibus[78]),
      .DATA_OUT   (REG_Q[75]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT76 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[78]),
      .TDO        (tdibus[79]),
      .DATA_OUT   (REG_Q[76]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT77 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[79]),
      .TDO        (tdibus[80]),
      .DATA_OUT   (REG_Q[77]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT78 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[80]),
      .TDO        (tdibus[81]),
      .DATA_OUT   (REG_Q[78]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT79 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[81]),
      .TDO        (tdibus[82]),
      .DATA_OUT   (REG_Q[79]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT80 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[82]),
      .TDO        (tdibus[83]),
      .DATA_OUT   (REG_Q[80]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT81 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[83]),
      .TDO        (tdibus[84]),
      .DATA_OUT   (REG_Q[81]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT82 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[84]),
      .TDO        (tdibus[85]),
      .DATA_OUT   (REG_Q[82]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT83 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[85]),
      .TDO        (tdibus[86]),
      .DATA_OUT   (REG_Q[83]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT84 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[86]),
      .TDO        (tdibus[87]),
      .DATA_OUT   (REG_Q[84]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT85 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[87]),
      .TDO        (tdibus[88]),
      .DATA_OUT   (REG_Q[85]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT86 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[88]),
      .TDO        (tdibus[89]),
      .DATA_OUT   (REG_Q[86]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT87 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[89]),
      .TDO        (tdibus[90]),
      .DATA_OUT   (REG_Q[87]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT88 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[90]),
      .TDO        (tdibus[91]),
      .DATA_OUT   (REG_Q[88]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT89 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[91]),
      .TDO        (tdibus[92]),
      .DATA_OUT   (REG_Q[89]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT90 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[92]),
      .TDO        (tdibus[93]),
      .DATA_OUT   (REG_Q[90]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT91 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[93]),
      .TDO        (tdibus[94]),
      .DATA_OUT   (REG_Q[91]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT92 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[94]),
      .TDO        (tdibus[95]),
      .DATA_OUT   (REG_Q[92]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT93 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[95]),
      .TDO        (tdibus[96]),
      .DATA_OUT   (REG_Q[93]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT94 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[96]),
      .TDO        (tdibus[97]),
      .DATA_OUT   (REG_Q[94]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT95 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[97]),
      .TDO        (tdibus[98]),
      .DATA_OUT   (REG_Q[95]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT96 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[98]),
      .TDO        (tdibus[99]),
      .DATA_OUT   (REG_Q[96]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT97 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[99]),
      .TDO        (tdibus[100]),
      .DATA_OUT   (REG_Q[97]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT98 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[100]),
      .TDO        (tdibus[101]),
      .DATA_OUT   (REG_Q[98]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT99 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[101]),
      .TDO        (tdibus[102]),
      .DATA_OUT   (REG_Q[99]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT100 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[102]),
      .TDO        (tdibus[103]),
      .DATA_OUT   (REG_Q[100]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT101 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[103]),
      .TDO        (tdibus[104]),
      .DATA_OUT   (REG_Q[101]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT102 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[104]),
      .TDO        (tdibus[105]),
      .DATA_OUT   (REG_Q[102]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT103 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[105]),
      .TDO        (tdibus[106]),
      .DATA_OUT   (REG_Q[103]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT104 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[106]),
      .TDO        (tdibus[107]),
      .DATA_OUT   (REG_Q[104]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT105 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[107]),
      .TDO        (tdibus[108]),
      .DATA_OUT   (REG_Q[105]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT106 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[108]),
      .TDO        (tdibus[109]),
      .DATA_OUT   (REG_Q[106]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT107 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[109]),
      .TDO        (tdibus[110]),
      .DATA_OUT   (REG_Q[107]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT108 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[110]),
      .TDO        (tdibus[111]),
      .DATA_OUT   (REG_Q[108]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT109 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[111]),
      .TDO        (tdibus[112]),
      .DATA_OUT   (REG_Q[109]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT110 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[112]),
      .TDO        (tdibus[113]),
      .DATA_OUT   (REG_Q[110]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT111 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[113]),
      .TDO        (tdibus[114]),
      .DATA_OUT   (REG_Q[111]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT112 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[114]),
      .TDO        (tdibus[115]),
      .DATA_OUT   (REG_Q[112]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT113 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[115]),
      .TDO        (tdibus[116]),
      .DATA_OUT   (REG_Q[113]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT114 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[116]),
      .TDO        (tdibus[117]),
      .DATA_OUT   (REG_Q[114]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT115 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[117]),
      .TDO        (tdibus[118]),
      .DATA_OUT   (REG_Q[115]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

 `ifdef DOWNLOAD_BUFFER_SIZE_256
TYPEA DATA_BIT116 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[118]),
      .TDO        (tdibus[119]),
      .DATA_OUT   (REG_Q[116]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT117 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[119]),
      .TDO        (tdibus[120]),
      .DATA_OUT   (REG_Q[117]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT118 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[120]),
      .TDO        (tdibus[121]),
      .DATA_OUT   (REG_Q[118]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT119 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[121]),
      .TDO        (tdibus[122]),
      .DATA_OUT   (REG_Q[119]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT120 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[122]),
      .TDO        (tdibus[123]),
      .DATA_OUT   (REG_Q[120]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT121 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[123]),
      .TDO        (tdibus[124]),
      .DATA_OUT   (REG_Q[121]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT122 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[124]),
      .TDO        (tdibus[125]),
      .DATA_OUT   (REG_Q[122]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT123 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[125]),
      .TDO        (tdibus[126]),
      .DATA_OUT   (REG_Q[123]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT124 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[126]),
      .TDO        (tdibus[127]),
      .DATA_OUT   (REG_Q[124]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT125 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[127]),
      .TDO        (tdibus[128]),
      .DATA_OUT   (REG_Q[125]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT126 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[128]),
      .TDO        (tdibus[129]),
      .DATA_OUT   (REG_Q[126]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT127 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[129]),
      .TDO        (tdibus[130]),
      .DATA_OUT   (REG_Q[127]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));
   
TYPEA DATA_BIT128 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[130]),
      .TDO        (tdibus[131]),
      .DATA_OUT   (REG_Q[128]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT129 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[131]),
      .TDO        (tdibus[132]),
      .DATA_OUT   (REG_Q[129]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT130 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[132]),
      .TDO        (tdibus[133]),
      .DATA_OUT   (REG_Q[130]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT131 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[133]),
      .TDO        (tdibus[134]),
      .DATA_OUT   (REG_Q[131]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT132 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[134]),
      .TDO        (tdibus[135]),
      .DATA_OUT   (REG_Q[132]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT133 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[135]),
      .TDO        (tdibus[136]),
      .DATA_OUT   (REG_Q[133]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT134 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[136]),
      .TDO        (tdibus[137]),
      .DATA_OUT   (REG_Q[134]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT135 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[137]),
      .TDO        (tdibus[138]),
      .DATA_OUT   (REG_Q[135]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT136 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[138]),
      .TDO        (tdibus[139]),
      .DATA_OUT   (REG_Q[136]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT137 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[139]),
      .TDO        (tdibus[140]),
      .DATA_OUT   (REG_Q[137]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT138 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[140]),
      .TDO        (tdibus[141]),
      .DATA_OUT   (REG_Q[138]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT139 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[141]),
      .TDO        (tdibus[142]),
      .DATA_OUT   (REG_Q[139]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT140 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[142]),
      .TDO        (tdibus[143]),
      .DATA_OUT   (REG_Q[140]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT141 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[143]),
      .TDO        (tdibus[144]),
      .DATA_OUT   (REG_Q[141]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT142 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[144]),
      .TDO        (tdibus[145]),
      .DATA_OUT   (REG_Q[142]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT143 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[145]),
      .TDO        (tdibus[146]),
      .DATA_OUT   (REG_Q[143]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT144 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[146]),
      .TDO        (tdibus[147]),
      .DATA_OUT   (REG_Q[144]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT145 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[147]),
      .TDO        (tdibus[148]),
      .DATA_OUT   (REG_Q[145]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT146 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[148]),
      .TDO        (tdibus[149]),
      .DATA_OUT   (REG_Q[146]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT147 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[149]),
      .TDO        (tdibus[150]),
      .DATA_OUT   (REG_Q[147]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT148 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[150]),
      .TDO        (tdibus[151]),
      .DATA_OUT   (REG_Q[148]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT149 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[151]),
      .TDO        (tdibus[152]),
      .DATA_OUT   (REG_Q[149]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT150 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[152]),
      .TDO        (tdibus[153]),
      .DATA_OUT   (REG_Q[150]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT151 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[153]),
      .TDO        (tdibus[154]),
      .DATA_OUT   (REG_Q[151]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT152 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[154]),
      .TDO        (tdibus[155]),
      .DATA_OUT   (REG_Q[152]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT153 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[155]),
      .TDO        (tdibus[156]),
      .DATA_OUT   (REG_Q[153]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT154 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[156]),
      .TDO        (tdibus[157]),
      .DATA_OUT   (REG_Q[154]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT155 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[157]),
      .TDO        (tdibus[158]),
      .DATA_OUT   (REG_Q[155]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT156 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[158]),
      .TDO        (tdibus[159]),
      .DATA_OUT   (REG_Q[156]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT157 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[159]),
      .TDO        (tdibus[160]),
      .DATA_OUT   (REG_Q[157]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT158 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[160]),
      .TDO        (tdibus[161]),
      .DATA_OUT   (REG_Q[158]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT159 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[161]),
      .TDO        (tdibus[162]),
      .DATA_OUT   (REG_Q[159]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT160 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[162]),
      .TDO        (tdibus[163]),
      .DATA_OUT   (REG_Q[160]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT161 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[163]),
      .TDO        (tdibus[164]),
      .DATA_OUT   (REG_Q[161]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT162 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[164]),
      .TDO        (tdibus[165]),
      .DATA_OUT   (REG_Q[162]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT163 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[165]),
      .TDO        (tdibus[166]),
      .DATA_OUT   (REG_Q[163]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT164 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[166]),
      .TDO        (tdibus[167]),
      .DATA_OUT   (REG_Q[164]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT165 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[167]),
      .TDO        (tdibus[168]),
      .DATA_OUT   (REG_Q[165]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT166 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[168]),
      .TDO        (tdibus[169]),
      .DATA_OUT   (REG_Q[166]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT167 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[169]),
      .TDO        (tdibus[170]),
      .DATA_OUT   (REG_Q[167]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT168 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[170]),
      .TDO        (tdibus[171]),
      .DATA_OUT   (REG_Q[168]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT169 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[171]),
      .TDO        (tdibus[172]),
      .DATA_OUT   (REG_Q[169]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT170 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[172]),
      .TDO        (tdibus[173]),
      .DATA_OUT   (REG_Q[170]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT171 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[173]),
      .TDO        (tdibus[174]),
      .DATA_OUT   (REG_Q[171]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT172 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[174]),
      .TDO        (tdibus[175]),
      .DATA_OUT   (REG_Q[172]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT173 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[175]),
      .TDO        (tdibus[176]),
      .DATA_OUT   (REG_Q[173]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT174 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[176]),
      .TDO        (tdibus[177]),
      .DATA_OUT   (REG_Q[174]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT175 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[177]),
      .TDO        (tdibus[178]),
      .DATA_OUT   (REG_Q[175]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT176 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[178]),
      .TDO        (tdibus[179]),
      .DATA_OUT   (REG_Q[176]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT177 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[179]),
      .TDO        (tdibus[180]),
      .DATA_OUT   (REG_Q[177]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT178 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[180]),
      .TDO        (tdibus[181]),
      .DATA_OUT   (REG_Q[178]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT179 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[181]),
      .TDO        (tdibus[182]),
      .DATA_OUT   (REG_Q[179]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT180 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[182]),
      .TDO        (tdibus[183]),
      .DATA_OUT   (REG_Q[180]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT181 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[183]),
      .TDO        (tdibus[184]),
      .DATA_OUT   (REG_Q[181]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT182 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[184]),
      .TDO        (tdibus[185]),
      .DATA_OUT   (REG_Q[182]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT183 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[185]),
      .TDO        (tdibus[186]),
      .DATA_OUT   (REG_Q[183]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT184 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[186]),
      .TDO        (tdibus[187]),
      .DATA_OUT   (REG_Q[184]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT185 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[187]),
      .TDO        (tdibus[188]),
      .DATA_OUT   (REG_Q[185]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT186 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[188]),
      .TDO        (tdibus[189]),
      .DATA_OUT   (REG_Q[186]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT187 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[189]),
      .TDO        (tdibus[190]),
      .DATA_OUT   (REG_Q[187]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT188 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[190]),
      .TDO        (tdibus[191]),
      .DATA_OUT   (REG_Q[188]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT189 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[191]),
      .TDO        (tdibus[192]),
      .DATA_OUT   (REG_Q[189]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT190 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[192]),
      .TDO        (tdibus[193]),
      .DATA_OUT   (REG_Q[190]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT191 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[193]),
      .TDO        (tdibus[194]),
      .DATA_OUT   (REG_Q[191]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT192 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[194]),
      .TDO        (tdibus[195]),
      .DATA_OUT   (REG_Q[192]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT193 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[195]),
      .TDO        (tdibus[196]),
      .DATA_OUT   (REG_Q[193]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT194 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[196]),
      .TDO        (tdibus[197]),
      .DATA_OUT   (REG_Q[194]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT195 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[197]),
      .TDO        (tdibus[198]),
      .DATA_OUT   (REG_Q[195]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT196 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[198]),
      .TDO        (tdibus[199]),
      .DATA_OUT   (REG_Q[196]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT197 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[199]),
      .TDO        (tdibus[200]),
      .DATA_OUT   (REG_Q[197]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT198 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[200]),
      .TDO        (tdibus[201]),
      .DATA_OUT   (REG_Q[198]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT199 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[201]),
      .TDO        (tdibus[202]),
      .DATA_OUT   (REG_Q[199]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT200 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[202]),
      .TDO        (tdibus[203]),
      .DATA_OUT   (REG_Q[200]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT201 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[203]),
      .TDO        (tdibus[204]),
      .DATA_OUT   (REG_Q[201]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT202 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[204]),
      .TDO        (tdibus[205]),
      .DATA_OUT   (REG_Q[202]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT203 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[205]),
      .TDO        (tdibus[206]),
      .DATA_OUT   (REG_Q[203]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT204 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[206]),
      .TDO        (tdibus[207]),
      .DATA_OUT   (REG_Q[204]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT205 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[207]),
      .TDO        (tdibus[208]),
      .DATA_OUT   (REG_Q[205]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT206 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[208]),
      .TDO        (tdibus[209]),
      .DATA_OUT   (REG_Q[206]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT207 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[209]),
      .TDO        (tdibus[210]),
      .DATA_OUT   (REG_Q[207]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT208 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[210]),
      .TDO        (tdibus[211]),
      .DATA_OUT   (REG_Q[208]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT209 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[211]),
      .TDO        (tdibus[212]),
      .DATA_OUT   (REG_Q[209]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT210 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[212]),
      .TDO        (tdibus[213]),
      .DATA_OUT   (REG_Q[210]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT211 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[213]),
      .TDO        (tdibus[214]),
      .DATA_OUT   (REG_Q[211]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT212 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[214]),
      .TDO        (tdibus[215]),
      .DATA_OUT   (REG_Q[212]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT213 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[215]),
      .TDO        (tdibus[216]),
      .DATA_OUT   (REG_Q[213]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT214 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[216]),
      .TDO        (tdibus[217]),
      .DATA_OUT   (REG_Q[214]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT215 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[217]),
      .TDO        (tdibus[218]),
      .DATA_OUT   (REG_Q[215]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT216 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[218]),
      .TDO        (tdibus[219]),
      .DATA_OUT   (REG_Q[216]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT217 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[219]),
      .TDO        (tdibus[220]),
      .DATA_OUT   (REG_Q[217]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT218 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[220]),
      .TDO        (tdibus[221]),
      .DATA_OUT   (REG_Q[218]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT219 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[221]),
      .TDO        (tdibus[222]),
      .DATA_OUT   (REG_Q[219]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT220 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[222]),
      .TDO        (tdibus[223]),
      .DATA_OUT   (REG_Q[220]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT221 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[223]),
      .TDO        (tdibus[224]),
      .DATA_OUT   (REG_Q[221]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT222 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[224]),
      .TDO        (tdibus[225]),
      .DATA_OUT   (REG_Q[222]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT223 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[225]),
      .TDO        (tdibus[226]),
      .DATA_OUT   (REG_Q[223]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT224 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[226]),
      .TDO        (tdibus[227]),
      .DATA_OUT   (REG_Q[224]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT225 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[227]),
      .TDO        (tdibus[228]),
      .DATA_OUT   (REG_Q[225]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT226 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[228]),
      .TDO        (tdibus[229]),
      .DATA_OUT   (REG_Q[226]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT227 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[229]),
      .TDO        (tdibus[230]),
      .DATA_OUT   (REG_Q[227]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT228 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[230]),
      .TDO        (tdibus[231]),
      .DATA_OUT   (REG_Q[228]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT229 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[231]),
      .TDO        (tdibus[232]),
      .DATA_OUT   (REG_Q[229]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT230 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[232]),
      .TDO        (tdibus[233]),
      .DATA_OUT   (REG_Q[230]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT231 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[233]),
      .TDO        (tdibus[234]),
      .DATA_OUT   (REG_Q[231]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT232 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[234]),
      .TDO        (tdibus[235]),
      .DATA_OUT   (REG_Q[232]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT233 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[235]),
      .TDO        (tdibus[236]),
      .DATA_OUT   (REG_Q[233]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT234 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[236]),
      .TDO        (tdibus[237]),
      .DATA_OUT   (REG_Q[234]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT235 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[237]),
      .TDO        (tdibus[238]),
      .DATA_OUT   (REG_Q[235]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT236 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[238]),
      .TDO        (tdibus[239]),
      .DATA_OUT   (REG_Q[236]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT237 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[239]),
      .TDO        (tdibus[240]),
      .DATA_OUT   (REG_Q[237]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT238 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[240]),
      .TDO        (tdibus[241]),
      .DATA_OUT   (REG_Q[238]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT239 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[241]),
      .TDO        (tdibus[242]),
      .DATA_OUT   (REG_Q[239]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT240 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[242]),
      .TDO        (tdibus[243]),
      .DATA_OUT   (REG_Q[240]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT241 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[243]),
      .TDO        (tdibus[244]),
      .DATA_OUT   (REG_Q[241]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT242 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[244]),
      .TDO        (tdibus[245]),
      .DATA_OUT   (REG_Q[242]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT243 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[245]),
      .TDO        (tdibus[246]),
      .DATA_OUT   (REG_Q[243]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT244 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[246]),
      .TDO        (tdibus[247]),
      .DATA_OUT   (REG_Q[244]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT245 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[247]),
      .TDO        (tdibus[248]),
      .DATA_OUT   (REG_Q[245]),
      .DATA_IN    (REG_D[245+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT246 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[248]),
      .TDO        (tdibus[249]),
      .DATA_OUT   (REG_Q[246]),
      .DATA_IN    (REG_D[246+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT247 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[249]),
      .TDO        (tdibus[250]),
      .DATA_OUT   (REG_Q[247]),
      .DATA_IN    (REG_D[247+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT248 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[250]),
      .TDO        (tdibus[251]),
      .DATA_OUT   (REG_Q[248]),
      .DATA_IN    (REG_D[248+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT249 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[251]),
      .TDO        (tdibus[252]),
      .DATA_OUT   (REG_Q[249]),
      .DATA_IN    (REG_D[249+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT250 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[252]),
      .TDO        (tdibus[253]),
      .DATA_OUT   (REG_Q[250]),
      .DATA_IN    (REG_D[250+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT251 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[253]),
      .TDO        (tdibus[254]),
      .DATA_OUT   (REG_Q[251]),
      .DATA_IN    (REG_D[251+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT252 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[254]),
      .TDO        (tdibus[255]),
      .DATA_OUT   (REG_Q[252]),
      .DATA_IN    (REG_D[252+11-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT253 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[255]),
      .TDO        (tdibus[256]),
      .DATA_OUT   (REG_Q[253]),
      .DATA_IN    (REG_ADDR_D[253+3-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT254 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[256]),
      .TDO        (tdibus[257]),
      .DATA_OUT   (REG_Q[254]),
      .DATA_IN    (REG_ADDR_D[254+3-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT255 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[257]),
      .TDO        (JTDO2),
      .DATA_OUT   (REG_Q[255]),
      .DATA_IN    (REG_ADDR_D[255+3-256]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

 `else
TYPEA DATA_BIT116 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[118]),
      .TDO        (tdibus[119]),
      .DATA_OUT   (REG_Q[116]),
      .DATA_IN    (1'b0),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT117 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[119]),
      .TDO        (tdibus[120]),
      .DATA_OUT   (REG_Q[117]),
      .DATA_IN    (REG_D[117+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT118 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[120]),
      .TDO        (tdibus[121]),
      .DATA_OUT   (REG_Q[118]),
      .DATA_IN    (REG_D[118+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT119 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[121]),
      .TDO        (tdibus[122]),
      .DATA_OUT   (REG_Q[119]),
      .DATA_IN    (REG_D[119+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT120 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[122]),
      .TDO        (tdibus[123]),
      .DATA_OUT   (REG_Q[120]),
      .DATA_IN    (REG_D[120+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT121 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[123]),
      .TDO        (tdibus[124]),
      .DATA_OUT   (REG_Q[121]),
      .DATA_IN    (REG_D[121+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT122 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[124]),
      .TDO        (tdibus[125]),
      .DATA_OUT   (REG_Q[122]),
      .DATA_IN    (REG_D[122+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT123 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[125]),
      .TDO        (tdibus[126]),
      .DATA_OUT   (REG_Q[123]),
      .DATA_IN    (REG_D[123+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT124 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[126]),
      .TDO        (tdibus[127]),
      .DATA_OUT   (REG_Q[124]),
      .DATA_IN    (REG_D[124+11-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT125 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[127]),
      .TDO        (tdibus[128]),
      .DATA_OUT   (REG_Q[125]),
      .DATA_IN    (REG_ADDR_D[125+3-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT126 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[128]),
      .TDO        (tdibus[129]),
      .DATA_OUT   (REG_Q[126]),
      .DATA_IN    (REG_ADDR_D[126+3-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA DATA_BIT127 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[129]),
      .TDO        (JTDO2),
      .DATA_OUT   (REG_Q[127]),
      .DATA_IN    (REG_ADDR_D[127+3-128]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));
 `endif //  `ifdef HAHA
`endif //  `ifdef CFG_FAST_DOWNLOAD_ENABLED
   
TYPEA ADDR_BIT0 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[7]),
      .TDO        (tdibus[8]),
      .DATA_OUT   (REG_ADDR_Q[0]),
      .DATA_IN    (REG_ADDR_D[0]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

TYPEA ADDR_BIT1 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[8]),
      .TDO        (tdibus[9]),
      .DATA_OUT   (REG_ADDR_Q[1]),
      .DATA_IN    (REG_ADDR_D[1]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));

`ifdef CFG_FAST_DOWNLOAD_ENABLED
TYPEA ADDR_BIT2 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[9]),
      .TDO        (tdibus[10]),
      .DATA_OUT   (REG_ADDR_Q[2]),
      .DATA_IN    (REG_ADDR_D[2]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));
`else
TYPEA ADDR_BIT2 (
      .CLK        (JTCK),
      .RESET_N    (JRSTN),
      .CLKEN      (clk_enable),
      .TDI        (tdibus[9]),
      .TDO        (JTDO2),
      .DATA_OUT   (REG_ADDR_Q[2]),
      .DATA_IN    (REG_ADDR_D[2]),
      .CAPTURE_DR (captureDr),
      .UPDATE_DR  (JUPDATE));
`endif   

   assign clk_enable = JTAGREG_ENABLE & JCE2;
   
   assign captureDr = !JSHIFT & JCE2;
   
   // JCE2 is only active during shift
   assign REG_UPDATE = JTAGREG_ENABLE & JUPDATE;
   
endmodule

