library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
entity mic32_vhd is
port(
clk_i   : in std_logic
; reset_n : in std_logic
; LEDPIO_OUT : out std_logic_vector(7 downto 0)
; sramsram_csn : out std_logic
; sramsram_be : out std_logic_vector(3 downto 0)
; flashsram_csn : out std_logic
; flashsram_be : out std_logic_vector(3 downto 0)
; flashsram_byten : out std_logic
; flashsram_wpn : out std_logic
; flashsram_rstn : out std_logic
; sramflashOEN : out std_logic
; sramflashWEN : out std_logic
; sramflashADDR : out std_logic_vector(24 downto 0)
; sramflashDATA : inout std_logic_vector(31 downto 0)
);
end mic32_vhd;

architecture mic32_vhd_a of mic32_vhd is

component mic32
   port(
      clk_i   : in std_logic
      ; reset_n : in std_logic
      ; LEDPIO_OUT : out std_logic_vector(7 downto 0)
      ; sramsram_csn : out std_logic
      ; sramsram_be : out std_logic_vector(3 downto 0)
      ; flashsram_csn : out std_logic
      ; flashsram_be : out std_logic_vector(3 downto 0)
      ; flashsram_byten : out std_logic
      ; flashsram_wpn : out std_logic
      ; flashsram_rstn : out std_logic
      ; sramflashOEN : out std_logic
      ; sramflashWEN : out std_logic
      ; sramflashADDR : out std_logic_vector(24 downto 0)
      ; sramflashDATA : inout std_logic_vector(31 downto 0)
      );
   end component;

   attribute black_box_pad_pin : string;
   attribute black_box_pad_pin of mic32 : component is "sramflashDATA(31:0)";
begin

lm32_inst : mic32
port map (
   clk_i  => clk_i
   ,reset_n  => reset_n
   ,LEDPIO_OUT  => LEDPIO_OUT
   ,sramsram_csn  => sramsram_csn
   ,sramsram_be  => sramsram_be
   ,flashsram_csn  => flashsram_csn
   ,flashsram_be  => flashsram_be
   ,flashsram_byten  => flashsram_byten
   ,flashsram_wpn  => flashsram_wpn
   ,flashsram_rstn  => flashsram_rstn
   ,sramflashOEN  => sramflashOEN
   ,sramflashWEN  => sramflashWEN
   ,sramflashADDR  => sramflashADDR
   ,sramflashDATA  => sramflashDATA
   );

end mic32_vhd_a;

